<script>
	import Saos from 'saos';
	import Article from '@/components/article.svelte';
	import back from '@/plugins/axios.js';
	import Main from '@/components/main.svelte';
	import { started_state, global_pot } from '@/plugins/store';
	import Counter from '@/components/counter.svelte';
	import { team_names, team_indicators } from '@/plugins/config.js';
	import { topics } from '@/plugins/store';
	import { socketStore } from '@/plugins/socket';
	import { onMount, onDestroy } from 'svelte';

	let articles = [];
	let team_pots = { 0: '0.00', 1: '0.00', 2: '0.00', 3: '0.00' };

	let teams_bg_gradients = {
		0: 'bg-gradient-to-br from-cyan-400/70 from-70% to-blue-200/70', // Bleu
		1: 'bg-gradient-to-br from-red-600/80 from-70% to-red-400/80', // Rouge
		2: 'bg-gradient-to-br from-orange-500/70 from-70% to-orange-300/70', // Orange
		3: 'bg-gradient-to-br from-purple-500/70 from-70% to-purple-300/70' // Violet
	};

	let team_bg_colors = {
		0: 'bg-blue-400', // Bleu
		1: 'bg-red-400', // Rouge
		2: 'bg-orange-400', // Orange
		3: 'bg-purple-400', // Violet
		4: 'bg-base-300' // Principal
	};

	back
		.get('/articles/')
		.then((response) => {
			articles = response.data;
			// Odd or even is used to not have a uniform grid
			for (let i = 0; i < articles.length; i++) {
				articles[i].odd = i % 2;
			}
		})
		.catch((error) => {
			console.log(error);
		});

	onMount(() => {
		topics.sub('teams.*.pot');
	});

	let unsubscribe;
	$: {
		if (!unsubscribe) {
			socketStore.update((store) => {
				unsubscribe = store.subscribe((message) => {
					// Do something with the message here
					try {
						let m = JSON.parse(message);

						// Operation message, ignore it
						if ('op' in m) {
							return;
						}

						if (m.r.match('teams\\.\\d+\\.pot')) {
							// Team pot update
							let teamId = Number(m.d.teamID);
							let pot = m.d.pot;
							pot = (pot / 100).toFixed(2).toString();
							team_pots[teamId] = pot;

							// Update team order
						}
					} catch (e) {
						console.log(e);
					}
				});
				return store;
			});
		}
	}

	onDestroy(() => {
		unsubscribe();
		topics.unsub('teams.*.pot');
	});
</script>

<div class="w-full mt-20 pl-5 pr-5 mb-20">
	<div class="container mx-auto space-y-20">
		<div class="">
			<Saos animation="swirl .6s cubic-bezier(.23,1.000,.32,1.000) both">
				<Main />
			</Saos>
		</div>
		{#if $started_state == 2 || $started_state == 3}
			<div class="columns-1 sm:columns-2 xl:columns-4 w-fit mx-auto space-y-5">
				{#each Object.entries(team_pots) as [t_id, pot]}
					{#if team_names[t_id]}
						<div class="w-72">
							<div
								class="w-72 grid grid-flow-row justify-items-center text-3xl font-extrabold rounded-lg p-5 {teams_bg_gradients[
									t_id
								]} space-y-5"
							>
								<span>{team_names[t_id]}</span>
								<Counter amount={pot} />
								<div class="items-center">
									<a
										class="btn btn-primary text-md normal-case hover:underline underline-offset-8 decoration-2"
										href="/streamers?team={t_id}">Leurs Streamers</a
									>
								</div>
							</div>
							<span class="team-indicator">{team_indicators[t_id]}</span>
						</div>
					{/if}
				{/each}
			</div>
			<div class="text-3xl font-extrabold mx-auto w-fit">
				<Counter text="Total récolté :" amount={$global_pot} />
			</div>
		{/if}
		{#each articles as a}
			{#if a.odd == 0}
				<div class="carousel-item relative w-full mb-10">
					<Saos once={true} animation="left .6s cubic-bezier(.23,1.000,.32,1.000) both">
						<div class="w-full md:pr-32 lg:pr-64">
							<Article article={a} />
						</div>
					</Saos>
				</div>
			{:else}
				<Saos once={true} animation="left .6s cubic-bezier(.23,1.000,.32,1.000) both">
					<div class="carousel-item relative w-full mb-10">
						<div class="w-full md:pl-32 lg:pl-64">
							<Article article={a} />
						</div>
					</div>
				</Saos>
			{/if}
		{/each}
	</div>
</div>

<style>
	@media (min-width: 600px) {
		@keyframes -global-right {
			0% {
				-webkit-transform: translateX(1000px) scaleX(2.5) scaleY(0.2);
				transform: translateX(1000px) scaleX(2.5) scaleY(0.2);
				-webkit-transform-origin: 0 50%;
				transform-origin: 0 50%;
				-webkit-filter: blur(40px);
				filter: blur(40px);
				opacity: 0;
			}
			100% {
				-webkit-transform: translateX(0) scaleY(1) scaleX(1);
				transform: translateX(0) scaleY(1) scaleX(1);
				-webkit-transform-origin: 50% 50%;
				transform-origin: 50% 50%;
				-webkit-filter: blur(0);
				filter: blur(0);
				opacity: 1;
			}
		}
		@keyframes slide-in-blurred-right {
			0% {
				-webkit-transform: translateX(1000px) scaleX(2.5) scaleY(0.2);
				transform: translateX(1000px) scaleX(2.5) scaleY(0.2);
				-webkit-transform-origin: 0 50%;
				transform-origin: 0 50%;
				-webkit-filter: blur(40px);
				filter: blur(40px);
				opacity: 0;
			}
			100% {
				-webkit-transform: translateX(0) scaleY(1) scaleX(1);
				transform: translateX(0) scaleY(1) scaleX(1);
				-webkit-transform-origin: 50% 50%;
				transform-origin: 50% 50%;
				-webkit-filter: blur(0);
				filter: blur(0);
				opacity: 1;
			}
		}
		@keyframes -global-left {
			0% {
				-webkit-transform: translateX(-1000px) scaleX(2.5) scaleY(0.2);
				transform: translateX(-1000px) scaleX(2.5) scaleY(0.2);
				-webkit-transform-origin: 100% 50%;
				transform-origin: 100% 50%;
				-webkit-filter: blur(40px);
				filter: blur(40px);
				opacity: 0;
			}
			100% {
				-webkit-transform: translateX(0) scaleY(1) scaleX(1);
				transform: translateX(0) scaleY(1) scaleX(1);
				-webkit-transform-origin: 50% 50%;
				transform-origin: 50% 50%;
				-webkit-filter: blur(0);
				filter: blur(0);
				opacity: 1;
			}
		}
		@keyframes slide-in-blurred-left {
			0% {
				-webkit-transform: translateX(-1000px) scaleX(2.5) scaleY(0.2);
				transform: translateX(-1000px) scaleX(2.5) scaleY(0.2);
				-webkit-transform-origin: 100% 50%;
				transform-origin: 100% 50%;
				-webkit-filter: blur(40px);
				filter: blur(40px);
				opacity: 0;
			}
			100% {
				-webkit-transform: translateX(0) scaleY(1) scaleX(1);
				transform: translateX(0) scaleY(1) scaleX(1);
				-webkit-transform-origin: 50% 50%;
				transform-origin: 50% 50%;
				-webkit-filter: blur(0);
				filter: blur(0);
				opacity: 1;
			}
		}
		@keyframes -global-swirl {
			0% {
				-webkit-transform: rotate(-540deg) scale(0);
				transform: rotate(-540deg) scale(0);
				-webkit-transform-origin: 50% 100%;
				transform-origin: 50% 100%;
				opacity: 0;
			}
			100% {
				-webkit-transform: rotate(0) scale(1);
				transform: rotate(0) scale(1);
				-webkit-transform-origin: 50% 100%;
				transform-origin: 50% 100%;
				opacity: 1;
			}
		}
		@keyframes swirl-in-bottom-fwd {
			0% {
				-webkit-transform: rotate(-540deg) scale(0);
				transform: rotate(-540deg) scale(0);
				-webkit-transform-origin: 50% 100%;
				transform-origin: 50% 100%;
				opacity: 0;
			}
			100% {
				-webkit-transform: rotate(0) scale(1);
				transform: rotate(0) scale(1);
				-webkit-transform-origin: 50% 100%;
				transform-origin: 50% 100%;
				opacity: 1;
			}
		}
	}

	.team-indicator {
		color: rgba(51, 51, 51, 0.629);
		font-size: larger;
		position: relative;
		top: -1.3em;
		float: right;
		margin-right: 0.5rem;
	}
</style>
